Hibernate JPA 2 project template
================================

Usage:
------
A basic JPA CRUD example

General:
--------
This project contains:

* `src/main/resources/META-INF/persistence.xml`

   Two persistence units offering a »drop-and-create«
   (re-creating schema) and a »strategy_none« (don't touch)JDBC database
   connection to a Mysql 5 server. You may want to adjust both database
   type and connection parameters.
 
* Important classes (package root `de.hdm_stuttgart.mi.sda1` omitted
  for brevity):

|File / Class              |Description                                |
|--------------------------|-------------------------------------------|
|`...model.StudyCourse`    |Class representing study courses           |
|`...CreateStudyCourse`    |Persisting a study course                  |
|`...ReadStudyCourseById`  |Retrieving a study course database instance by primary key   |

* `src/main/resources/log4j2.xml` Configuring the log4j subsystem.

On executing i.e. »`mvn install`« Maven will 
[generate]
(https://docs.jboss.org/hibernate/orm/current/topical/html_single/metamodelgen/MetamodelGenerator.html)
metamodel classes like `StudyCourse_.java` during the
»`generate-sources`« phase. These classes are being required for
[typesafe criteria based queries]
(http://docs.jboss.org/hibernate/entitymanager/3.6/reference/en/html/querycriteria.html#querycriteria-typedquery)
not being used in this project.


Targets:
--------

* `mvn test`
  Creating and re-reading a database instance of `StudyCourse`.
  Connection parameters being defined twice in two persistence units in
  `src/main/resources/META-INF/persistence.xml`.

* `mvn package`
  Creating an executable jar persisting an `StudyCourse` instance to be
  run like e.g.:

    java -jar target/intro-1.0.jar