  package de.hdm_stuttgart.mi.sda1;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import de.hdm_stuttgart.mi.sda1.model.StudyCourse;

  /**
   * Create a transient {@link StudyCourse} instance and persist it to the database.
   */
  public class CreateStudyCourse {

  static private final Logger log = LogManager.getLogger(CreateStudyCourse.class);

  /**
   * @param args Unused
   */
  public static void main( String[] args ) {

    final EntityManagerFactory factory = Persistence.createEntityManagerFactory(
      "strategy_drop-and-create");
    final EntityManager em = factory.createEntityManager();

    log.info("Begin transaction");

    final EntityTransaction tx = em.getTransaction();

    tx.begin();
      final StudyCourse csm = new StudyCourse(
          "CSM", "Computer Science an Media");

      em.persist(csm);
    tx.commit();

    log.info("Committed transaction");

    // See http://stackoverflow.com/questions/21645516/program-using-hibernate-does-not-terminate
    factory.close();
  }
}